import es
import random
import playerlib
import gamethread

import wcs
from wcs import wcs

Name = "Paladin"
race = wcs.Race(Name)

race.registerAuthor("||K9||Wolf||")

race.registerSkill("Divine Armor",  5,1, "Increases your armor.")
race.registerSkill("Devotion Aura", 5,1, "Increases your health.")
race.registerSkill("Healing Aura",  8,1, "Creates an aura to heal your teammates. <+Ability>")
race.registerSkill("Divine Shield", 5,1, "You push back nearby enemies. <+Abiliy2>")
race.registerSkill("Divine Sword",  8,1, "Increases the damage of your sword.")
race.registerUltimate("Invulnerability",8,5,1, "Invincible. <+Ultimate>")

def player_spawn(ev):
    userid = ev['userid']
    
    if wcs.GetRace(userid) == Name:
        
        wcs.Command(userid).SpeedAdd(.15)
        wcs.Command(userid).SetGravity(.8)
        wcs.Command(userid).UpdateDict("HealingAura", 0)
        
        dArmor = wcs.GetLevel(userid,Name,"Divine Armor")
        if dArmor:
            Paladin.DivineArmor(userid)
        
        dAura = wcs.GetLevel(userid,Name,"Devotion Aura")
        if dAura:
            Paladin.DevotionAura(userid)

def player_hurt(ev):
    userid   = ev['userid']
    attacker = ev['attacker']
    weapon   = ev['weapon']
    damage   = int(ev['dmg_health'])

    if weapon == "knife":
        dSword = wcs.GetLevel(attacker,Name,"Divine Sword")
        if dSword:
            Paladin.DivineSword(ev,attacker,userid,damage)

#Freddukes Healing Ward skill
def player_ability_on(ev):
    userid = ev['userid']
    if wcs.GetRace(userid) == Name:
        if wcs.GetLevel(userid,Name,"Healing Aura"):
            if wcs.Command(userid).ReturnDict("HealingAura") == 0:
                Paladin.initHealingAura(userid)
            else:
                es.tell(userid,"#multi","#greenHealing Aura #default- #lightgreenYou have already used your aura.")

def player_ability_on2(ev):
    userid = ev['userid']
    team   = es.getplayerteam(userid)
    
    if team == 2:
        filter = '#ct'
    elif team == 3:
        filter = '#t'

    dShield = wcs.GetLevel(userid,Name,"Divine Shield")
    if dShield:
        Paladin.DivineShield(userid,filter)

def PushLoop(userid, attacker):
    level      = wcs.GetLevel(attacker,Name,"Divine Shield")
    amountPush = level * 300
    
    playerlib.getPlayer(userid).set("push",(-1 * amountPush,0,0))
    es.tell(attacker,"#multi","#greenDivine Shield #default- #lightgreenYou have pushed nearby enemies with you divine shield.") 
    es.tell(userid,"#multi","#greenDivine Shield #default- #lightgreenYou have been pushed by a divine shield.")

def player_ultimate_on(ev):
    userid = ev['userid']
    
    invul = wcs.GetLevel(userid,Name,"Invulnerability")
    if invul:
        Paladin.Invulnerability(userid)

class PaladinSkills:
     
    def DivineArmor(self,userid):
        level       = wcs.GetLevel(userid,Name,"Divine Armor")
        armorAmount = level * 80
        
        wcs.Command(userid).ArmorAdd(armorAmount)
        es.tell(userid,"#multi","#greenDivine Armor #default- #lightgreenYou have been given \'#green%s#lightgreen\' more armor."%armorAmount)

    def DevotionAura(self,userid):
        level      = wcs.GetLevel(userid,Name,"Devotion Aura")
        auraAmount = level * 40
        
        wcs.Command(userid).HealthAdd(auraAmount)
        es.tell(userid,"#multi","#greenDevotion Aura #default- #lightgreenYou have been given \'#green%s#lightgreen\' more health."%auraAmount)

    def initHealingAura(self,userid):
        x,y,z = es.getplayerlocation(userid)
        wcs.Command(userid).UpdateDict("HealingAura", 1)
        self.healingAura(userid,x,y,z)
    
    def HealingAura(self,userid,x,y,z):
        if wcs.Command(userid).ReturnDict("HealingAura") == 1:
            level = wcs.GetLevel(userid,Name,"Healing Aura")
            team = es.getplayerteam(userid)
            tRange = 400
            level = wcs.GetLevel(userid,Name,"Healing Aura")
            healAmount = level * 2
            targets = []
            for player in playerlib.getPlayerList("#alive"):
                xx, yy, zz = es.getplayerlocation(int(player))
                range = ((x - xx) ** 2 + (y - yy) ** 2 + (z - zz) ** 2) ** 0.5
                if range <= tRange:
                    targets.append(int(player))
            wcs.Effect().RingCustom("#all", 0, "sprites/purpleglow1.vmt", x, y, z, 5, tRange, 10, 20, 20, 20,  10, 10, 250, 180, 10)
            wcs.Effect().RingCustom("#all", 0, "sprites/purpleglow1.vmt", x, y, z, 5, tRange, 10, 20, 20, 20,  10, 10, 250, 180, 12)
            wcs.Effect().RingCustom("#all", 0, "sprites/purpleglow1.vmt", x, y, z, 5, tRange, 10, 20, 20, 20,  10, 10, 250, 180, 14)
            wcs.Effect().RingCustom("#all", 0, "sprites/purpleglow1.vmt", x, y, z, 5, tRange, 10, 20, 20, 20,  10, 10, 250, 180, 16)
            wcs.Effect().RingCustom("#all", 0, "sprites/purpleglow1.vmt", x, y, z, 5, tRange, 10, 20, 20, 20,  10, 10, 250, 180, 18)
            wcs.Effect().RingCustom("#all", 0, "sprites/purpleglow1.vmt", x, y, z, 5, tRange, 10, 20, 20, 20,  10, 10, 250, 180, 20)
            for target in targets:
                x1,y1,z1 = es.getplayerlocation(target)
                wcs.Command(target).Heal(healAmount)
                es.tell(target,"#multi","#greenHealing Aura #default- #lightgreenYou have been healed by an enchanted aura.")
                wcs.Effect().BeamCustom("#all", 0, "materials/sprites/laser.vmt", x, y, z, x1, y1, z1 , 2, 5, 5, 10, 10, 250, 255)
            gamethread.delayed(10, self.HealingAura, (userid,x,y,z) )
    
    def DivineShield(self,userid,filter):
        level    = wcs.GetLevel(userid,Name,"Divine Shield")
        distance = level * 20 
        
        wcs.Command(userid).Near(distance,PushLoop,filter)
    
    def DivineSword(self,ev,attacker,userid,damage):
        level        = wcs.GetLevel(attacker,Name,"Divine Sword")
        amountDamage = .01 * (level * damage)
        
        wcs.Command(userid).Damage(amountDamage,4,attacker)
        es.tell(attacker,"#multi","#greenDivine Sword #default- #lightgreenYou have dealt \'#green%s#lightgreen\' more damage."%amountDamage)
        es.tell(userid,"#multi","#greenDivine Sword #default- #lightgreenYou have been dealt \'#green%s#lightgreen\' more damage."%amountDamage)

    def Invulnerability(self,userid):
        level = wcs.GetLevel(userid,Name,"Invulnerability")
        time  = level * 2
        
        wcs.Command(userid).God(time)
        wcs.Command(userid).SetCoolDown("Invulnerability",60)
        es.tell(userid,"#multi","#greenInvulnerability #default- #lightgreenYou are invulnerable for \'#green%s#lightgreen\' seconds."%time)


Paladin = PaladinSkills()